import awt.*;
import browser.Applet;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Hashtable;
import net.www.html.URL;


class ImageTapeLoader extends Thread {
	ImageTape parent;
	
	ImageTapeLoader (ImageTape parent) {
		this.parent = parent;
		start();
		}
	public void run() {
		Image img;
		int n = 1;
		
                while ((img = parent.getImage (parent.dir + "/" + parent.urlarr[n])) != null) {

		n++;
		parent.add(img);
		}
	}
}

class ImageTape extends browser.Applet implements Runnable {
    Image imgs[] = new Image[100];
    String urlarr[] = new String [100]; 
    int widtharr[] = new int [100]; 
    int accum[] = new int [100]; 
    int num = 1;
    int nimgs;
    int imgwidth;
    int totalwidth = 0;
    int x, newx;
    int fix;
    int dist = 1;
    int timeout;
    int mousepos;
    Thread scroller;
    String dir;
    String showstat;
    String url;
    String statuschk;
    boolean loaded;
    boolean top;
    boolean in = false;
    URL anchor;

    public void init() {
	String at = getAttribute("img");
	dir = "./logos";
	System.out.println("DIR="+dir);
	at = getAttribute("speed");
	timeout = 1000 / ((at == null) ? 4 : Integer.valueOf(at).intValue());
	at = getAttribute("dir");
	dist = (at == null) ? 5 : Integer.valueOf(at).intValue();
	//System.out.println("DIR = " + dist);
	newx = x = width;



        String s[] = new String[64]; 
	num = 1;
        while (true) {
           
                s[num] = getAttribute("url"+num);
                if (s[num] == null) {  
		break;
                } 
                urlarr[num] = s[num];
                num++;
        }        

    }

//fix this part once there are some examples

    public void mouseDown (int x, int y) {
       widtharr[0] = 0;
       accum[0] = 0;
       for (int i = 0 ;i < (num) ; i++) {
               accum[0] = (accum[0] + widtharr[(i)]);
                if ( ((totalwidth - fix) + mousepos ) > totalwidth ) {
                        if ( (fix + mousepos) >= (accum[0]) && (fix + mousepos ) <= (accum[0]+widtharr[i])){
                        anchor = new URL(null, "http://localhost:7999/" + urlarr[i]);                        showDocument(anchor);
                        break;
                        }
                } else{
                        if ( ((totalwidth - fix) + mousepos) >= (accum[0]) && ((totalwidth - fix) + mousepos ) <= (accum[0]+widtharr[i])){
               		anchor = new URL(null, "http://localhost:7999/" + urlarr[i+1]);
                        showDocument(anchor);
               		break;
                        }
               } 
       } 
    }

    public void start() {
	if (!loaded) {
	    loaded = true;
	    new ImageTapeLoader(this);
	}
	if (scroller == null) {
	    scroller = new Thread(this);
	    scroller.start();
	}
    }
    public void stop() {
	if (scroller != null) {
	    scroller.stop();
	    scroller = null;
	}
    }

    public void run() {
	while (true) {
	    Thread.currentThread().sleep(timeout);
	    scroll(dist);
	}
    }

   public void mouseExit (){
    in = false;

    showStatus( " ") ;	
   }
//this needs alittle tweeking for the very first image 
   public void statusShow (){
       showStatus( "Click to select: "  + showstat ) ;
       widtharr[0] = 0;
       accum[0] = 0;
       for (int i = 0 ;i < (num) ; i++) {
               accum[0] = (accum[0] + widtharr[(i)]);
		if ( ((totalwidth - fix) + mousepos ) > totalwidth ) {	
               		if ( (fix + mousepos) >= (accum[0]) && (fix + mousepos ) <= (accum[0]+widtharr[i])){
               		showstat = urlarr[i];
			}
		} else{
               		if ( ((totalwidth - fix) + mousepos) >= (accum[0]) && ((totalwidth - fix) + mousepos ) <= (accum[0]+widtharr[i])){
               		showstat = urlarr[i+1];
			}
               } 
       } 
	return;
    }
    /**
     * Find the ImageAreas that the mouse is in.
     */  
   public void mouseMove(int x, int y) {
   in = true;
   mousepos = x;
   //statusShow();
   }


    synchronized void scroll(int dist) {
	repaint();
    }

    public synchronized void add(Image img) {
	imgs[nimgs] = img;
	imgwidth += img.width;
	totalwidth = (totalwidth + img.width);
	widtharr[nimgs] = img.width;
	nimgs++;
	if (isActive()) {
	    repaint();
	}
    }

    public synchronized void update(Graphics g) {
        newx += dist;

	g.setForeground(Color.lightGray);

	if (newx != x) {
	    //g.clipRect(1, 1, width-2, height-2);
 	    int dist = newx - x;
	    if (dist > 0) {

		g.copyArea(1, 1, (width-2) - dist, height-2, dist + 1, 1);
		for (x = newx ; x > width ; x -= Math.max(width - 2, imgwidth));
		paint(g, 1, dist + 1);
	    } else {
		g.copyArea(1 - dist, 1, (width-2) + dist, height-2, 1, 1);
		for (x = newx ; x < 0 ; x += Math.max(width - 2, imgwidth));
		paint(g, (width-1) + dist, width-1);
	    }
        if ( in ) {
        statusShow();
	}
	} else {
	    paint(g);
	}
    }

    public synchronized void paint(Graphics g, int fromx, int tox) {
	int x = this.x;
	newx = x;
	fix = x;

	g.setForeground(Color.lightGray);
	g.fillRect(fromx, 1, tox - fromx, height-2);
	g.clipRect(fromx, 1, tox - fromx, height-2);
	g.setForeground(Color.black);

	for (int i = 0 ; i < nimgs ; i++) {
	    if ((x + imgs[i].width > fromx) && (x < tox)) {
		g.drawImage(imgs[i], x, height - (imgs[i].height+1));
	    }
	    if ((x + imgs[i].width) > width) {
		x -= Math.max(width - 2, imgwidth);
		if ((x + imgs[i].width > fromx) && (x < tox)) {
		    g.drawImage(imgs[i], x, height - (imgs[i].height + 1));
		}
	    }
	    x += imgs[i].width;
	}
    }
    public synchronized void paint(Graphics g) {
	g.paint3DRect(0, 0, width, height, false, true);
	paint(g, 1, width-1);
    }
}
