import browser.Applet;    
import awt.Color;
import awt.Graphics;
import awt.Image;


class clrText extends Applet {
    Color textColor=null;
    Color shadow=null;
    int textx;
    int texty;
    Image baseImage;
    boolean size = true;

    public void init() {
        baseImage = getImage(getAttribute("img"));
        String color = getAttribute("color");
        if (color != null) {
            System.out.println("The color is: " + color);
            // set shadow to white automatically
            shadow = awt.Color.white;
            if (color.equals("white"))
                textColor = awt.Color.white;
            else if (color.equals("red"))
                textColor = awt.Color.red;
            else if (color.equals("blue"))
                textColor = awt.Color.blue;
        }
        else
            System.out.println("No valid color was specified");
    }

    public void paint(Graphics g) {
       if (size) {
        resize(baseImage.width, baseImage.height);
        } else {
        resize(baseImage.width + 50 , baseImage.height + 50);
        }

        g.drawImage(baseImage, 0, 0);
 
        g.drawRect(0, 0, width - 1, height - 1);
        for (int i = 0 ; i < width - 1 ; i += 8) {
            g.drawLine(i, 0, width - 1, height - 1);
        }
        for (int i = 0 ; i < height - 1 ; i += 8) {
            g.drawLine(0, 0, width - i, height - 1);
        }
	// draw shadow

        String text = getAttribute("text");

        g.setForeground(shadow);
        g.drawString(text, textx -1 , texty + 1);

        if (textColor != null) {
            g.setForeground(textColor);
        }
        g.drawString(text, textx, texty);
    }
    public void mouseDown(int x, int y) {
	size = false;
        repaint();
    }

    public void mouseDrag(int x, int y) {
        textx = x;
	texty = y;	
        repaint();
    }
    public void mouseUp(int x, int y) {
	size = true;
	repaint();
        play("beep.au");
    }
}
